const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const item_redemptions = sequelize.define(
    'item_redemptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

redeemed_at: {
        type: DataTypes.DATE,
      
      

      },

cost_doodlecoins: {
        type: DataTypes.INTEGER,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"REQUESTED",


"APPROVED",


"FULFILLED",


"REJECTED",


"CANCELLED"

        ],

      },

note: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  item_redemptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.item_redemptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.item_redemptions.belongsTo(db.shop_items, {
      as: 'shop_item',
      foreignKey: {
        name: 'shop_itemId',
      },
      constraints: false,
    });




    db.item_redemptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.item_redemptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return item_redemptions;
};


